--https://love2d.org/forums/viewtopic.php?p=256194#p256194
local lg = love.graphics
local resw=lg.getWidth()
local resh=lg.getHeight()
local imgData = love.image.newImageData(16,16)
for y=0, 15 do
for x=0, 15 do
	local a = 1-math.sqrt(((x-8)*(x-8)) + ((y-8)*(y-8))) / 7
   imgData:setPixel(x, y, 0.9, a, 0.7, a) --x, y, r, g, b, a
end
end
local img = love.graphics.newImage(imgData)
local ps = love.graphics.newParticleSystem(img, 50)
ps:setParticleLifetime(3, 5)
ps:setEmissionRate(5)
ps:setSizeVariation(0.5)
ps:setLinearAcceleration(-100, -100, 100, 100) -- Random movement in all directions.
ps:setColors(1, 1, 1, 1,  1, 1, 1, 1,  1, 1, 1, 0)
ps:setSizes( 1, 10, 10 )
local a = 0
local t = 0
function love.update (dt)
	if love.mouse.isDown(1) then a=a-dt*4 end
	if love.mouse.isDown(2) then a=a+dt*4 end
	ps:update(dt)
	t=t+dt
end

function love.draw ()
	lg.stencil(flashLight, "replace", 1)
	lg.setStencilTest("greater", 0)
	--draw your flashlight "light color" here --vv
	lg.setColor(1, 1, 1, 0.1)
	lg.rectangle ("fill",0,0,800, 600) --flashlight background ("light color")
	--uncomment for flickering light
	--for i=1,100,1 do
	--	lg.rectangle ("fill", math.random(0,resw), math.random(0,resh), 20,20)
	--end
	--------------------------------------------^^
	---draw your game graphics here--vv
	lg.setColor(1,1,1,1)
	lg.draw(ps, lg.getWidth()/2, lg.getHeight()/2)
	lg.rectangle ("fill",100,100,200,200)
	lg.setColor(1,0,0,1)
	lg.print ("the best text is here", 200,280,0,4,4)
	---------------------------------^^
	lg.setStencilTest()
	lg.print ("use mouse to move light\nclick left/right to rotate", 10,10,0,2,2)
end

--everything you draw in here, will become "light"
function flashLight()
	lg.setColor (1,1,1,0.5)
	local x,y=love.mouse.getPosition()
	lg.circle ("fill", x,y, 50)
	lg.arc ("fill","pie", x,y, 200, -a-0.5,-a+0.5)
	lg.circle ("fill", resw/2+math.sin(t)*300, resh/2+math.cos(t+1)*200, 100)
	lg.circle ("fill", resw/2+math.sin(t)*300, resh/2, 40)
end

function love.keypressed(key)
	if key == "escape" then love.event.quit() end
end--
